IMPLEMENTATION MODULE DrvMem;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *********************************************************************
    Compilers:  TopSpeed / Stony Brook Modula-2
    ---------------------------------------------------------------------
    A.Iakovlev  Ver  1.0  Initial version                     October 94
    A.Iakovlev  Ver  2.0  Renaming                            March 95
    *********************************************************************
    TopSpeed library dependencies:
    ------ import from Storage: Available, ALLOCATE, DEALLOCATE
    Stony Brook library dependencies:
    ------ import from Storage: Available, ALLOCATE, DEALLOCATE
  *)

  IMPORT SYSTEM, Storage, SrvLow;

  PROCEDURE Alloc(VAR a: SYSTEM.ADDRESS; n: CARDINAL): BOOLEAN;
    BEGIN
      IF Storage.Available(n) THEN
        Storage.ALLOCATE(a, n);
        SrvLow.FastFill(a, n, 0);
        RETURN TRUE;
      ELSE
        a := NIL;
        RETURN FALSE;
      END;
    END Alloc;

  PROCEDURE Free(VAR a: SYSTEM.ADDRESS; n: CARDINAL);
    BEGIN
      IF a # NIL THEN
        Storage.DEALLOCATE(a, n);
        a := NIL;
      END;
    END Free;

  END DrvMem.
