IMPLEMENTATION MODULE DrvMou;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *********************************************************************
    Hardware :  IBM PC/XT/AT BIOS + PC Mouse / Microsoft Mouse
    OpSystem :  MS-DOS & TopSpeed DOS Extender
    Compilers:  TopSpeed / Stony Brook Modula-2
    ---------------------------------------------------------------------
    D.Maslov    Ver  1.0                                      October 90
    A.Iakovlev  Ver  2.0  Simplifications                     February 91
    A.Iakovlev  Ver  2.1  Use %T DOS instead of %F OS2        January 92
    A.Iakovlev  Ver  2.2  Version for TopSpeed DOS Extender   January 92
    A.Iakovlev  Ver  3.0  Pragma data(var_enum_size)          August 92
    A.Iakovlev  Ver  4.0  Renaming                            June 93
    A.Iakovlev  Ver  4.1  Import from SYSTEM                  January 94
    A.Iakovlev  Ver  4.2  No OS/2 support                     February 94
    A.Iakovlev  Ver  4.3  Use module SrvSys                   February 94
    A.Iakovlev  Ver  5.0  Renaming                            March 95
    *********************************************************************
    ROM BIOS & MS-DOS dependencies:
    ------ mouse driver at INT 33H (functions 0, 3, 0BH)
    ------ call BIOS via interrupt
    TopSpeed compiler dependencies:
    ------ pragmas (*#...*)
    TopSpeed DOS Extender dependencies:
    ------ necessity to initialize the interceptor for mouse interrupt
    ------ procedure TSXLIB.InitInt33
  *)

  FROM Cfg IMPORT EXTTS;
  IMPORT SrvSys;

  (* ================== Conditional import *)

  (*%T EXTTS*)
  IMPORT TSXLIB;
  (*%E*)

  (* ============== Global variable and it's request *)

  VAR nmbOfButtons: CARDINAL;

  PROCEDURE ButtonsNmb(): CARDINAL;
    BEGIN
      RETURN nmbOfButtons;
    END ButtonsNmb;

  (* ============================= Hardware/OpSystem interface *)

  CONST
    MouseInterrupt = 33H;
    ResetFun = 0H;
    GetStatusAndPosFun = 3H;
    ReadMotionFun = 0BH;

  PROCEDURE Get(VAR s: ButtonSet; VAR dx, dy: INTEGER): BOOLEAN;
    VAR
      reg: SrvSys.Registers;
    BEGIN
      IF nmbOfButtons > 0 THEN
        (* ------------------ get state of buttons *)
        reg.AX := GetStatusAndPosFun;
        SrvSys.Int(reg, MouseInterrupt);
        s := ButtonSet(reg.BX);
        (* ------------------------- get motion counters *)
        reg.AX := ReadMotionFun;
        SrvSys.Int(reg, MouseInterrupt);
        dx := VAL(INTEGER, reg.CX);
        dy := VAL(INTEGER, reg.DX);
        (* ---------------------------------- return status *)
        RETURN (s # ButtonSet{}) OR (dx # 0) OR (dy # 0);
      ELSE
        RETURN FALSE;
      END;
    END Get;

  PROCEDURE init();
    VAR
      reg: SrvSys.Registers;
    BEGIN
      reg.AX := ResetFun;
      SrvSys.Int(reg, MouseInterrupt);
      IF reg.AX = MAX(CARDINAL) THEN
        nmbOfButtons := reg.BX;
      ELSE
        nmbOfButtons := 0;
      END;
    END init;

  (* =========================== Initialization *)

  BEGIN
  (*%T EXTTS*)
    TSXLIB.InitInt33();
  (*%E*)
    init();
  END DrvMou.
