; Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
; ****************************************************************************
; Assembler:  MASM 5.1+
; Compilers:  TopSpeed / Stony Brook Modula-2
; ----------------------------------------------------------------------------
; A.Iakovlev  Ver  1.0  Initial version                           August 90
; A.Iakovlev  Ver  2.0  Procedures MoveShInc/MoveShDec            August 90
; A.Iakovlev  Ver  3.0  Procedures in XOR-mode                    August 90
; A.Iakovlev  Ver  4.0  Procedures with prereading                September 90
; A.Iakovlev  Ver  5.0  Fast procedures                           December 90
; A.Iakovlev  Ver  6.0  Filling procedures                        May 91
; A.Iakovlev  Ver  7.0  Segment-oriented procedures               May 91
; A.Iakovlev  Ver  8.0  Renaming                                  June 93
; A.Iakovlev  Ver  9.0  Import from SYSTEM                        January 94
; A.Iakovlev  Ver 10.0  Scan procedures                           February 94
; A.Iakovlev  Ver 11.0  Font procedure                            February 94
; A.Iakovlev  Ver 12.0  Shift procedures                          February 94
; A.Iakovlev  Ver 13.0  Stony Brook support                       February 94
; A.Iakovlev  Ver 13.1  Rewriting to MASM assembler               February 94
; A.Iakovlev  Ver 14.0  Word-oriented procedures                  October 94
; A.Iakovlev  Ver 15.0  Trio-byte-oriented procedures             October 94
; A.Iakovlev  Ver 16.0  Renaming                                  March 95
; ****************************************************************************
; TopSpeed compiler dependencies (in DEF-module):
; ------ options (*$...*) and pragmas (*#...*)
; ------ inline procedures
; ------ import from SYSTEM: BYTE
; ------ predefined type LONGCARD
; Stony Brook compiler dependencies (in DEF-module):
; ------ options (*/...*)
; ------ external names
; ------ import from SYSTEM: BYTE
; ------ predefined type LONGCARD

SrvLow_TEXT                SEGMENT byte public 'CODE'
                           ASSUME cs:SrvLow_TEXT

; ========================================== Byte-oriented fill procedures

                           PUBLIC SrvLow$Fill
SrvLow$Fill                PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill bytes
                           rep   stosb
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$Fill                ENDP

                           PUBLIC SrvLow$FastFill
SrvLow$FastFill            PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill beginning byte (if need)
                           test  di, 1
                           jz    $FastFill$Even
                           stosb
                           dec   cx
                           ; --------------- fill inner bytes
$FastFill$Even:            shr   cx, 1
                           mov   ah, al
                           rep   stosw
                           ; --------------- fill end byte (if need)
                           adc   cx, cx
                           rep   stosb
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FastFill            ENDP

                           PUBLIC SrvLow$FillOr
SrvLow$FillOr              PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill bytes
$FillOr$BeginLoop:         or    es:[di], al
                           inc   di
                           loop  $FillOr$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FillOr              ENDP

                           PUBLIC SrvLow$FastFillOr
SrvLow$FastFillOr          PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill beginning byte (if need)
                           test  di, 1
                           jz    $FastFillOr$Even
                           or    es:[di], al
                           inc   di
                           dec   cx
                           ; --------------- fill inner bytes
$FastFillOr$Even:          shr   cx, 1
                           pushf
                           mov   ah, al
$FastFillOr$BeginLoop:     jcxz  $FastFillOr$EndLoop
                           or    es:[di], ax
                           inc   di
                           inc   di
                           dec   cx
                           jmp   $FastFillOr$BeginLoop
                           ; --------------- fill end byte (if need)
$FastFillOr$EndLoop:       popf
                           adc   cx, cx
                           jcxz  $FastFillOr$End
                           or    es:[di], al
                           ; --------------- restore registers
$FastFillOr$End:           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FastFillOr          ENDP

                           PUBLIC SrvLow$FillAnd
SrvLow$FillAnd             PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill bytes
$FillAnd$BeginLoop:        and   es:[di], al
                           inc   di
                           loop  $FillAnd$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FillAnd             ENDP

                           PUBLIC SrvLow$FastFillAnd
SrvLow$FastFillAnd         PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill beginning byte (if need)
                           test  di, 1
                           jz    $FastFillAnd$Even
                           and   es:[di], al
                           inc   di
                           dec   cx
                           ; --------------- fill inner bytes
$FastFillAnd$Even:         shr   cx, 1
                           pushf
                           mov   ah, al
$FastFillAnd$BeginLoop:    jcxz  $FastFillAnd$EndLoop
                           and   es:[di], ax
                           inc   di
                           inc   di
                           dec   cx
                           jmp   $FastFillAnd$BeginLoop
                           ; --------------- fill end byte (if need)
$FastFillAnd$EndLoop:      popf
                           adc   cx, cx
                           jcxz  $FastFillAnd$End
                           and   es:[di], al
                           ; --------------- restore registers
$FastFillAnd$End:          pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FastFillAnd         ENDP

                           PUBLIC SrvLow$FillXor
SrvLow$FillXor             PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill bytes
$FillXor$BeginLoop:        xor   es:[di], al
                           inc   di
                           loop  $FillXor$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FillXor             ENDP

                           public SrvLow$FastFillXor
SrvLow$FastFillXor         PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill beginning byte (if need)
                           test  di, 1
                           jz    $FastFillXor$Even
                           xor   es:[di], al
                           inc   di
                           dec   cx
                           ; --------------- fill inner bytes
$FastFillXor$Even:         shr   cx, 1
                           pushf
                           mov   ah, al
$FastFillXor$BeginLoop:    jcxz  $FastFillXor$EndLoop
                           xor   es:[di], ax
                           inc   di
                           inc   di
                           dec   cx
                           jmp   $FastFillXor$BeginLoop
                           ; --------------- fill end byte (if need)
$FastFillXor$EndLoop:      popf
                           adc   cx, cx
                           jcxz  $FastFillXor$End
                           xor   es:[di], al
                           ; --------------- restore registers
$FastFillXor$End:          pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$FastFillXor         ENDP

                           public SrvLow$Refill
SrvLow$Refill              PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill bytes
$Refill$BeginLoop:         mov   ah, es:[di]
                           stosb
                           loop  $Refill$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$Refill              ENDP

                           PUBLIC SrvLow$SegFill
SrvLow$SegFill             PROC FAR
                           ; --------------- parameters
                           dst   = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           mov   es, [bp][dst]
                           sub   di, di
                           mov   cx, 8000H
                           mov   al, [bp][value]
                           mov   ah, al
                           cld
                           ; --------------- fill bytes
                           rep   stosw
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$SegFill             ENDP

; ========================================== Word-oriented fill procedures

                           PUBLIC SrvLow$WordFill
SrvLow$WordFill            PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           wsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][wsize]
                           mov   al, [bp][value]
                           cld
                           ; --------------- fill words
                           rep   stosw
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$WordFill            ENDP

                           PUBLIC SrvLow$WordFillXor
SrvLow$WordFillXor         PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           wsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][wsize]
                           mov   ax, [bp][value]
                           cld
                           ; --------------- fill words
$WordFillXor$BeginLoop:    xor   es:[di], ax
                           inc   di
                           inc   di
                           loop  $WordFillXor$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$WordFillXor         ENDP

                           PUBLIC SrvLow$WordSegFill
SrvLow$WordSegFill         PROC FAR
                           ; --------------- parameters
                           dst   = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           mov   es, [bp][dst]
                           sub   di, di
                           mov   cx, 8000H
                           mov   ax, [bp][value]
                           cld
                           ; --------------- fill words
                           rep   stosw
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$WordSegFill         ENDP

; ========================================== Byte-oriented move procedures

                           PUBLIC SrvLow$MoveInc
SrvLow$MoveInc             PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           cld
                           ; --------------- copy bytes
                           rep   movsb
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$MoveInc             ENDP

                           PUBLIC SrvLow$MoveDec
SrvLow$MoveDec             PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           std
                           ; --------------- copy bytes
                           rep   movsb
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$MoveDec             ENDP

                           PUBLIC SrvLow$FastMoveInc
SrvLow$FastMoveInc         PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           cld
                           ; --------------- copy beginning byte (if need)
                           test  di, 1
                           jz    $FastMoveInc$Even
                           movsb
                           dec   cx
                           ; --------------- copy inner words
$FastMoveInc$Even:         shr   cx, 1
                           rep   movsw
                           ; --------------- copy end byte (if need)
                           adc   cx, cx
                           rep   movsb
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$FastMoveInc         ENDP

                           PUBLIC SrvLow$FastMoveDec
SrvLow$FastMoveDec         PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           std
                           ; --------------- copy end byte (if need)
                           test  di, 1
                           jnz   $FastMoveDec$Odd
                           movsb
                           dec   cx
                           ; --------------- copy inner words
$FastMoveDec$Odd:          dec   si
                           dec   di
                           shr   cx, 1
                           rep   movsw
                           ; --------------- copy beginning byte (if need)
                           inc   si
                           inc   di
                           adc   cx, cx
                           rep   movsb
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$FastMoveDec         ENDP

                           PUBLIC SrvLow$MoveXorInc
SrvLow$MoveXorInc          PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           cld
                           ; --------------- copy bytes
$MoveXorInc$BeginLoop:     lodsb
                           xor   es:[di], al
                           inc   di
                           loop  $MoveXorInc$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$MoveXorInc          ENDP

                           PUBLIC SrvLow$MoveXorDec
SrvLow$MoveXorDec          PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           std
                           ; --------------- copy bytes
$MoveXorDec$BeginLoop:     lodsb
                           xor   es:[di], al
                           dec   di
                           loop  $MoveXorDec$BeginLoop
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$MoveXorDec          ENDP

                           PUBLIC SrvLow$FastMoveXorInc
SrvLow$FastMoveXorInc      PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           cld
                           ; --------------- copy beginning byte (if need)
                           test  di, 1
                           jz    $FastMoveXorInc$Even
                           lodsb
                           xor   es:[di], al
                           inc   di
                           dec   cx
                           ; --------------- copy inner words
$FastMoveXorInc$Even:      shr   cx, 1
                           pushf
$FastMoveXorInc$BeginLoop: jcxz  $FastMoveXorInc$EndLoop
                           lodsw
                           xor   es:[di], ax
                           inc   di
                           inc   di
                           dec   cx
                           jmp   $FastMoveXorInc$BeginLoop
                           ; --------------- copy end byte (if need)
$FastMoveXorInc$EndLoop:   popf
                           adc   cx, cx
                           jcxz  $FastMoveXorInc$End
                           lodsb
                           xor   es:[di], al
                           ; --------------- restore registers
$FastMoveXorInc$End:       pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$FastMoveXorInc      ENDP

                           PUBLIC SrvLow$FastMoveXorDec
SrvLow$FastMoveXorDec      PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           std
                           ; --------------- copy end byte (if need)
                           test  di, 1
                           jnz   $FastMoveXorDec$Odd
                           lodsb
                           xor   es:[di], al
                           dec   di
                           dec   cx
                           ; --------------- copy inner words
$FastMoveXorDec$Odd:       dec   si
                           dec   di
                           shr   cx, 1
                           pushf
$FastMoveXorDec$BeginLoop: jcxz  $FastMoveXorDec$EndLoop
                           lodsw
                           xor   es:[di], ax
                           dec   di
                           dec   di
                           dec   cx
                           jmp   $FastMoveXorDec$BeginLoop
                           ; --------------- copy beginning byte (if need)
$FastMoveXorDec$EndLoop:   inc   si
                           inc   di
                           popf
                           adc   cx, cx
                           jcxz  $FastMoveXorDec$End
                           lodsb
                           xor   es:[di], al
                           ; --------------- restore registers
$FastMoveXorDec$End:       cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$FastMoveXorDec      ENDP

                           PUBLIC SrvLow$RemoveInc
SrvLow$RemoveInc           PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           cld
                           ; --------------- main loop
$RemoveInc$BeginLoop:      lodsb
                           mov   ah, es:[di]
                           stosb
                           loop  $RemoveInc$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$RemoveInc           ENDP

                           PUBLIC SrvLow$RemoveDec
SrvLow$RemoveDec           PROC FAR
                           ; --------------- parameters
                           src   = 12
                           dst   = 8
                           bsize = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   cx, [bp][bsize]
                           std
                           ; --------------- main loop
$RemoveDec$BeginLoop:      lodsb
                           mov   ah, es:[di]
                           stosb
                           loop  $RemoveDec$BeginLoop
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$RemoveDec           ENDP

                           PUBLIC SrvLow$SegMoveInc
SrvLow$SegMoveInc          PROC FAR
                           ; --------------- parameters
                           src   = 8
                           dst   = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           mov   ds, [bp][src]
                           sub   si, si
                           mov   es, [bp][dst]
                           sub   di, di
                           mov   cx, 8000H
                           cld
                           ; --------------- main loop
                           rep   movsw
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$SegMoveInc          ENDP

                           PUBLIC SrvLow$SegMoveDec
SrvLow$SegMoveDec          PROC FAR
                           ; --------------- parameters
                           src   = 8
                           dst   = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           mov   ds, [bp][src]
                           mov   si, 0FFFEH
                           mov   es, [bp][dst]
                           mov   di, 0FFFEH
                           mov   cx, 8000H
                           std
                           ; --------------- main loop
                           rep   movsw
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$SegMoveDec          ENDP

; ========================================== Byte-oriented move-and-shift procedures

                           PUBLIC SrvLow$MoveShInc
SrvLow$MoveShInc           PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           cld
                           ; --------------- preread the beginning byte
                           lodsb
                           shl   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$MoveShInc$BeginLoop:      lodsb
                           sub   ah, ah
                           shl   ax, cl
                           or    ah, ch
                           mov   ch, al
                           mov   al, ah
                           stosb
                           dec   bx
                           jnz   $MoveShInc$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$MoveShInc           ENDP

                           PUBLIC SrvLow$MoveShDec
SrvLow$MoveShDec           PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           std
                           ; --------------- preread the end byte
                           lodsb
                           shr   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$MoveShDec$BeginLoop:      lodsb
                           mov   ah, al
                           sub   al, al
                           shr   ax, cl
                           or    al, ch
                           mov   ch, ah
                           stosb
                           dec   bx
                           jnz   $MoveShDec$BeginLoop
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$MoveShDec           ENDP

                           PUBLIC SrvLow$MoveShXorInc
SrvLow$MoveShXorInc        PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           cld
                           ; --------------- preread the beginning byte
                           lodsb
                           shl   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$MoveShXorInc$BeginLoop:   lodsb
                           sub   ah, ah
                           shl   ax, cl
                           or    ah, ch
                           mov   ch, al
                           xor   es:[di], ah
                           inc   di
                           dec   bx
                           jnz   $MoveShXorInc$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$MoveShXorInc        ENDP

                           PUBLIC SrvLow$MoveShXorDec
SrvLow$MoveShXorDec        PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           std
                           ; --------------- preread the end byte
                           lodsb
                           shr   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$MoveShXorDec$BeginLoop:   lodsb
                           mov   ah, al
                           sub   al, al
                           shr   ax, cl
                           or    al, ch
                           mov   ch, ah
                           xor   es:[di], al
                           dec   di
                           dec   bx
                           jnz   $MoveShXorDec$BeginLoop
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$MoveShXorDec        ENDP

                           PUBLIC SrvLow$RemoveShInc
SrvLow$RemoveShInc         PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           cld
                           ; --------------- preread the beginning byte
                           lodsb
                           shl   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$RemoveShInc$BeginLoop:    lodsb
                           sub   ah, ah
                           shl   ax, cl
                           or    ah, ch
                           mov   ch, al
                           mov   al, ah
                           mov   ah, es:[di]
                           stosb
                           dec   bx
                           jnz   $RemoveShInc$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$RemoveShInc         ENDP

                           PUBLIC SrvLow$RemoveShDec
SrvLow$RemoveShDec         PROC FAR
                           ; --------------- parameters
                           src   = 14
                           dst   = 10
                           bsize = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  ds
                           push  es
                           push  si
                           push  di
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           les   di, [bp][dst]
                           mov   bx, [bp][bsize]
                           mov   cx, [bp][shift]
                           and   cx, 7
                           std
                           ; --------------- preread the end byte
                           lodsb
                           shr   al, cl
                           mov   ch, al
                           ; --------------- read-shift-combine-write the byte
$RemoveShDec$BeginLoop:    lodsb
                           mov   ah, al
                           sub   al, al
                           shr   ax, cl
                           or    al, ch
                           mov   ch, ah
                           mov   ah, es:[di]
                           stosb
                           dec   bx
                           jnz   $RemoveShDec$BeginLoop
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   si
                           pop   es
                           pop   ds
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   12
SrvLow$RemoveShDec         ENDP

; ========================================== Byte-oriented scan procedures

                           PUBLIC SrvLow$ScanEqInc
SrvLow$ScanEqInc           PROC FAR
                           ; --------------- parameters
                           src   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][src]
                           mov   cx, [bp][bsize]
                           mov   ax, [bp][value]
                           cld
                           ; --------------- scan bytes
                           jcxz  $ScanEqInc$Exit
                           repnz scasb
                           jne   $ScanEqInc$Exit
                           inc   cx
                           ; --------------- compute result
$ScanEqInc$Exit:           mov   ax, [bp][bsize]
                           sub   ax, cx
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$ScanEqInc           ENDP

                           PUBLIC SrvLow$ScanNeInc
SrvLow$ScanNeInc           PROC FAR
                           ; --------------- parameters
                           src   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][src]
                           mov   cx, [bp][bsize]
                           mov   ax, [bp][value]
                           cld
                           ; --------------- scan bytes
                           jcxz  $ScanNeInc$Exit
                           rep   scasb
                           je    $ScanNeInc$Exit
                           inc   cx
                           ; --------------- compute result
$ScanNeInc$Exit:           mov   ax, [bp][bsize]
                           sub   ax, cx
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$ScanNeInc           ENDP

                           PUBLIC SrvLow$ScanEqDec
SrvLow$ScanEqDec           PROC FAR
                           ; --------------- parameters
                           src   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][src]
                           mov   cx, [bp][bsize]
                           mov   ax, [bp][value]
                           std
                           ; --------------- scan bytes
                           jcxz  $ScanEqDec$Exit
                           repnz scasb
                           jne   $ScanEqDec$Exit
                           inc   cx
                           ; --------------- compute result
$ScanEqDec$Exit:           mov   ax, [bp][bsize]
                           sub   ax, cx
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$ScanEqDec           ENDP

                           public SrvLow$ScanNeDec
SrvLow$ScanNeDec           PROC FAR
                           ; --------------- parameters
                           src   = 10
                           bsize = 8
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][src]
                           mov   cx, [bp][bsize]
                           mov   ax, [bp][value]
                           std
                           ; --------------- scan bytes
                           jcxz  $ScanNeDec$Exit
                           rep   scasb
                           je    $ScanNeDec$Exit
                           inc   cx
                           ; --------------- compute result
$ScanNeDec$Exit:           mov   ax, [bp][bsize]
                           sub   ax, cx
                           ; --------------- restore registers
                           cld
                           pop   di
                           pop   es
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$ScanNeDec           ENDP

; ========================================== Trio-oriented procedures

                           PUBLIC SrvLow$TrioFill
SrvLow$TrioFill            PROC FAR
                           ; --------------- parameters
                           dst   = 12
                           tsize = 10
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][tsize]
                           mov   ax, [bp][value]
                           mov   bl, [bp][value + 2]
                           ; --------------- fill
$TrioFill$BeginLoop:       stosw
                           mov   es:[di], bl
                           inc   di
                           loop  $TrioFill$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$TrioFill            ENDP

                           PUBLIC SrvLow$TrioFillXor
SrvLow$TrioFillXor         PROC FAR
                           ; --------------- parameters
                           dst   = 12
                           tsize = 10
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  cx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   cx, [bp][tsize]
                           mov   ax, [bp][value]
                           mov   bl, [bp][value + 2]
                           ; --------------- fill in XOR-mode
$TrioFillXor$BeginLoop:    xor   es:[di], al
                           inc   di
                           xor   es:[di], ah
                           inc   di
                           xor   es:[di], bl
                           inc   di
                           loop  $TrioFillXor$BeginLoop
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   cx
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   10
SrvLow$TrioFillXor         ENDP

                           PUBLIC SrvLow$TrioPut
SrvLow$TrioPut             PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   ax, [bp][value]
                           mov   bl, [bp][value + 2]
                           ; --------------- fill three bytes
                           stosw
                           mov   es:[di], bl
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$TrioPut             ENDP

                           PUBLIC SrvLow$TrioPutXor
SrvLow$TrioPutXor          PROC FAR
                           ; --------------- parameters
                           dst   = 10
                           value = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  es
                           push  di
                           ; --------------- load parameters into registers
                           les   di, [bp][dst]
                           mov   ax, [bp][value]
                           mov   bl, [bp][value + 2]
                           ; --------------- fill three bytes in XOR-mode
                           xor   es:[di], al
                           inc   di
                           xor   es:[di], ah
                           inc   di
                           xor   es:[di], bl
                           ; --------------- restore registers
                           pop   di
                           pop   es
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   8
SrvLow$TrioPutXor          ENDP

                           PUBLIC SrvLow$TrioGet
SrvLow$TrioGet             PROC FAR
                           ; --------------- parameters
                           src   = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  ds
                           push  si
                           ; --------------- load parameters into registers
                           lds   si, [bp][src]
                           ; --------------- read three bytes
                           lodsw
                           mov   dl, ds:[si]
                           sub   dh, dh
                           ; --------------- restore registers
                           pop   si
                           pop   ds
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$TrioGet             ENDP

; ========================================== Shift procedures

                           PUBLIC SrvLow$Shl
SrvLow$Shl                 PROC FAR
                           ; --------------- parameters
                           value = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           ; --------------- load parameters into registers
                           mov   ax, [bp][value]
                           mov   cl, [bp][shift]
                           ; --------------- left shift
                           shl   ax, cl
                           ; --------------- restore registers
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$Shl                 ENDP

                           PUBLIC SrvLow$Shr
SrvLow$Shr                 PROC FAR
                           ; --------------- parameters
                           value = 8
                           shift = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  cx
                           ; --------------- load parameters into registers
                           mov   ax, [bp][value]
                           mov   cl, [bp][shift]
                           ; --------------- right shift
                           shr   ax, cl
                           ; --------------- restore registers
                           pop   cx
                           ; --------------- epilogue
                           pop   bp
                           ret   4
SrvLow$Shr                 ENDP

; ========================================== Font procedure

                           PUBLIC SrvLow$FontAddr
SrvLow$FontAddr            PROC FAR
                           ; --------------- parameters
                           number = 6
                           ; --------------- begin
                           push  bp
                           mov   bp, sp
                           ; --------------- store registers
                           push  bx
                           push  es
                           ; --------------- load parameters into registers
                           mov   bh, [bp][number]
                           ; --------------- issue video interrupt
                           mov   ax, 1130H
                           int   10H
                           mov   dx, es
                           mov   ax, bp
                           ; --------------- restore registers
                           pop   es
                           pop   bx
                           ; --------------- epilogue
                           pop   bp
                           ret   2
SrvLow$FontAddr            ENDP

SrvLow_TEXT                ENDS

                           END
