IMPLEMENTATION MODULE WinInp;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *********************************************************************
    A.Iakovlev  Ver  1.0  Derived from module WinIO          January 90
    A.Iakovlev  Ver  2.0  Attributes by value                February 90
    A.Iakovlev  Ver  3.0  Changes in attributes              February 90
    A.Iakovlev  Ver  4.0  Renaming                           February 90
    A.Iakovlev  Ver  4.1  Monitor results in module Win      March 90
    A.Iakovlev  Ver  5.0  Use new module SimpIn              April 90
    A.Iakovlev  Ver  5.1  FullyVisible instead off PutOnTop  April 90
    A.Iakovlev  Ver  6.0  Changes in attributes              July 90
    A.Iakovlev  Ver  7.0  Return status, new SimpIn          July 90
    A.Iakovlev  Ver  8.0  Screen level redesign              October 90
    D.Maslov    Ver  9.0  Actions instead of key pressings   January 91
    D.Maslov    Ver 10.0  Procedure String                   January 91
    A.Iakovlev  Ver 10.1  Use new module Win                 February 91
    A.Iakovlev  Ver 11.0  Parameter wait:PROC                February 91
    A.Iakovlev  Ver 12.0  Procedure FillRect                 March 91
    A.Iakovlev  Ver 12.1  New type Win.Inland                April 91
    A.Iakovlev  Ver 13.0  Correction in type Status          June 91
    A.Iakovlev  Ver 14.0  Use module Res                     August 92
    A.Iakovlev  Ver 15.0  Renaming                           June 93
    A.Iakovlev  Ver 16.0  Use new united module ScrOut       March 95
    *********************************************************************
  *)

  IMPORT Geo, Res, ScrOut, ScrInp, Win;

  PROCEDURE Marker(u: Win.WINDOW;
            VAR a: ScrOut.Attrs; VAR p: Geo.Point;
            wait: PROC; get: ScrInp.GetPosAction): Res.Status;
    VAR
      i: Win.Inland;
      res: Res.Status;
    BEGIN
      IF Win.FullyVisible(u) THEN
        Win.Get(u, i);
        INC(p.ix, i.org.ix);
        INC(p.iy, i.org.iy);
        res := ScrInp.Marker(i.pixmap, a, p, wait, get);
        DEC(p.ix, i.org.ix);
        DEC(p.iy, i.org.iy);
        Win.Release(u);
        RETURN res;
      ELSE
        RETURN Res.invalidWindow;
      END;
    END Marker;

  PROCEDURE Rectangle(u: Win.WINDOW;
            VAR a: ScrOut.Attrs; VAR r: Geo.Rectangle;
            wait: PROC; get: ScrInp.GetPosAction): Res.Status;
    VAR
      i: Win.Inland;
      res: Res.Status;
    BEGIN
      IF Win.FullyVisible(u) THEN
        Win.Get(u, i);
        Geo.ShiftRect(r, i.org.ix, i.org.iy);
        res := ScrInp.Rectangle(i.pixmap, a, r, wait, get);
        Geo.ShiftRect(r, - i.org.ix, - i.org.iy);
        Win.Release(u);
        RETURN res;
      ELSE
        RETURN Res.invalidWindow;
      END;
    END Rectangle;

  PROCEDURE String(u: Win.WINDOW;
            VAR a: ScrOut.Attrs; VAR p: Geo.Point; VAR s: ARRAY OF CHAR;
            wait: PROC; get: ScrInp.GetTxtAction): Res.Status;
    VAR
      i: Win.Inland;
      res: Res.Status;
    BEGIN
      IF Win.FullyVisible(u) THEN
        Win.Get(u, i);
        INC(p.ix, i.org.ix);
        INC(p.iy, i.org.iy);
        res := ScrInp.String(i.pixmap, a, p, s, wait, get);
        DEC(p.ix, i.org.ix);
        DEC(p.iy, i.org.iy);
        Win.Release(u);
        RETURN res;
      ELSE
        RETURN Res.invalidWindow;
      END;
    END String;

  END WinInp.
